Scriptname SOS_RevealingArmorMagicEffect_Script extends activemagiceffect  

;----------PROPERTIES----------

SOS_SetupQuest_Script Property SOS_Quest Auto

FormList Property SOS_Factions Auto             ; DEPRECATED
FormList Property SOS_GenitalArmors Auto        ; DEPRECATED
FormList Property SOS_RevealingArmors Auto      ; DEPRECATED
FormList Property SOS_ConcealingArmors Auto     ; DEPRECATED
Keyword Property SOS_Concealing Auto
Keyword Property SOS_Revealing Auto

;----------EVENTS----------

Event OnEffectFinish(Actor akTarget, Actor akCaster)

	Armor bodyArmor = akTarget.GetWornForm(0x00000004) as Armor
	If !bodyArmor
		Return
	EndIf
	
	Armor genitals = StorageUtil.FormListGet(SOS_Quest.GetActiveAddon(akTarget), "SOS_GenitalArmors", 0) as Armor
	
	Debug.trace("SOS_RevealingArmorMagicEffect: " + akTarget + ", arm = " + bodyArmor + ", gen = " + genitals)
	
	If StorageUtil.FormListHas(None, "SOS_RevealingArmors", bodyArmor)
		StorageUtil.FormListRemove(None, "SOS_RevealingArmors", bodyArmor)
		StorageUtil.FormListAdd(None, "SOS_ConcealingArmors", bodyArmor, allowDuplicate = false)
		if (!bodyArmor.HasKeyword(SOS_Revealing))
			bodyArmor.AddSlotToMask(0x00400000)
		endIf
		akTarget.RemoveItem(genitals, 999, true)
		Debug.Trace("SOS_RevealingArmorMagicEffect: Armor set to concealing.")
		SOS_Quest.Notify(bodyArmor.GetName() + " set to be a Concealing Armor") ; todo translate
	Elseif StorageUtil.FormListHas(None, "SOS_ConcealingArmors", bodyArmor) || Math.LogicalAnd(bodyArmor.GetSlotMask(), 0x00400000)
		StorageUtil.FormListRemove(None, "SOS_ConcealingArmors", bodyArmor)
		StorageUtil.FormListAdd(None, "SOS_RevealingArmors", bodyArmor, allowDuplicate = false)
		bodyArmor.RemoveSlotFromMask(0x00400000)
		akTarget.EquipItem(genitals, false, true)
		SOS_Quest.UpdateNiNodes(akTarget)
		Debug.Trace("SOS_RevealingArmorMagicEffect: Armor set to revealing.")
		SOS_Quest.Notify(bodyArmor.GetName() + " set to be a Revealing Armor") ; todo translate
	EndIf

EndEvent
